<?php

namespace Service\ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfEPartecipante ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfEPartecipante
 * @subpackage Arrays
 */
class ArrayOfEPartecipante extends AbstractStructArrayBase
{
    /**
     * The EPartecipante
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \Service\StructType\EPartecipante[]
     */
    public $EPartecipante;
    /**
     * Constructor method for ArrayOfEPartecipante
     * @uses ArrayOfEPartecipante::setEPartecipante()
     * @param \Service\StructType\EPartecipante[] $ePartecipante
     */
    public function __construct(array $ePartecipante = array())
    {
        $this
            ->setEPartecipante($ePartecipante);
    }
    /**
     * Get EPartecipante value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \Service\StructType\EPartecipante[]|null
     */
    public function getEPartecipante()
    {
        return isset($this->EPartecipante) ? $this->EPartecipante : null;
    }
    /**
     * This method is responsible for validating the values passed to the setEPartecipante method
     * This method is willingly generated in order to preserve the one-line inline validation within the setEPartecipante method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateEPartecipanteForArrayConstraintsFromSetEPartecipante(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfEPartecipanteEPartecipanteItem) {
            // validation for constraint: itemType
            if (!$arrayOfEPartecipanteEPartecipanteItem instanceof \Service\StructType\EPartecipante) {
                $invalidValues[] = is_object($arrayOfEPartecipanteEPartecipanteItem) ? get_class($arrayOfEPartecipanteEPartecipanteItem) : sprintf('%s(%s)', gettype($arrayOfEPartecipanteEPartecipanteItem), var_export($arrayOfEPartecipanteEPartecipanteItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The EPartecipante property can only contain items of type \Service\StructType\EPartecipante, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set EPartecipante value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \Service\StructType\EPartecipante[] $ePartecipante
     * @return \Service\ArrayType\ArrayOfEPartecipante
     */
    public function setEPartecipante(array $ePartecipante = array())
    {
        // validation for constraint: array
        if ('' !== ($ePartecipanteArrayErrorMessage = self::validateEPartecipanteForArrayConstraintsFromSetEPartecipante($ePartecipante))) {
            throw new \InvalidArgumentException($ePartecipanteArrayErrorMessage, __LINE__);
        }
        if (is_null($ePartecipante) || (is_array($ePartecipante) && empty($ePartecipante))) {
            unset($this->EPartecipante);
        } else {
            $this->EPartecipante = $ePartecipante;
        }
        return $this;
    }
    /**
     * Add item to EPartecipante value
     * @throws \InvalidArgumentException
     * @param \Service\StructType\EPartecipante $item
     * @return \Service\ArrayType\ArrayOfEPartecipante
     */
    public function addToEPartecipante(\Service\StructType\EPartecipante $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \Service\StructType\EPartecipante) {
            throw new \InvalidArgumentException(sprintf('The EPartecipante property can only contain items of type \Service\StructType\EPartecipante, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->EPartecipante[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \Service\StructType\EPartecipante|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \Service\StructType\EPartecipante|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \Service\StructType\EPartecipante|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \Service\StructType\EPartecipante|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \Service\StructType\EPartecipante|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string EPartecipante
     */
    public function getAttributeName()
    {
        return 'EPartecipante';
    }
}
